# Record Class MArchitectureName

java.lang.Object
java.lang.Record
com.io7m.montarre.api.MArchitectureName

Record Components:
  `name` - The name

All Implemented Interfaces:
  `Comparable<MArchitectureName>`

public record MArchitectureName(String name) extends Record implements Comparable<MArchitectureName>
A hardware architecture name.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `MArchitectureName(String name)`
  A hardware architecture name.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static MArchitectureName`
  `aarch_64()`
  `static MArchitectureName`
  `arm_32()`
  `int`
  `compareTo(MArchitectureName o)`
  `final boolean`
  `equals(Object o)`
  Indicates whether some other object is "equal to" this one.
  `final int`
  `hashCode()`
  Returns a hash code value for this object.
  `static MArchitectureName`
  `infer(String name)`
  Infer an architecture from the given string.
  `static MArchitectureName`
  `loongarch_64()`
  `static MArchitectureName`
  `mips_32()`
  `static MArchitectureName`
  `mips_64()`
  `static MArchitectureName`
  `mipsle_32()`
  `static MArchitectureName`
  `mipsle_64()`
  `String`
  `name()`
  Returns the value of the `name` record component.
  `static MArchitectureName`
  `ppc_32()`
  `static MArchitectureName`
  `ppc_64()`
  `static MArchitectureName`
  `ppcle_32()`
  `static MArchitectureName`
  `ppcle_64()`
  `static MArchitectureName`
  `riscv_32()`
  `static MArchitectureName`
  `riscv_64()`
  `static MArchitectureName`
  `s390_64()`
  `static MArchitectureName`
  `sparc_32()`
  `static MArchitectureName`
  `sparc_64()`
  `String`
  `toString()`
  Returns a string representation of this record class.
  `static MArchitectureName`
  `unknown()`
  `static Pattern`
  `valid()`
  `static MArchitectureName`
  `x86_32()`
  `static MArchitectureName`
  `x86_64()`

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### MArchitectureName

    public MArchitectureName(String name)
    A hardware architecture name.
    Parameters:
      `name` - The name

- ## Method Details

  - ### valid

    public static Pattern valid()
    Returns:
      The pattern that defines validity

  - ### unknown

    public static MArchitectureName unknown()
    Returns:
      The unknown architecture

  - ### infer

    public static MArchitectureName infer(String name)
    Infer an architecture from the given string.
    Parameters:
      `name` - The name
    Returns:
      The architecture or `unknown()`

  - ### loongarch_64

    public static MArchitectureName loongarch_64()
    Returns:
      A standard architecture name

  - ### riscv_64

    public static MArchitectureName riscv_64()
    Returns:
      A standard architecture name

  - ### riscv_32

    public static MArchitectureName riscv_32()
    Returns:
      A standard architecture name

  - ### ppcle_64

    public static MArchitectureName ppcle_64()
    Returns:
      A standard architecture name

  - ### ppc_64

    public static MArchitectureName ppc_64()
    Returns:
      A standard architecture name

  - ### ppcle_32

    public static MArchitectureName ppcle_32()
    Returns:
      A standard architecture name

  - ### ppc_32

    public static MArchitectureName ppc_32()
    Returns:
      A standard architecture name

  - ### mipsle_64

    public static MArchitectureName mipsle_64()
    Returns:
      A standard architecture name

  - ### mipsle_32

    public static MArchitectureName mipsle_32()
    Returns:
      A standard architecture name

  - ### mips_64

    public static MArchitectureName mips_64()
    Returns:
      A standard architecture name

  - ### mips_32

    public static MArchitectureName mips_32()
    Returns:
      A standard architecture name

  - ### aarch_64

    public static MArchitectureName aarch_64()
    Returns:
      A standard architecture name

  - ### arm_32

    public static MArchitectureName arm_32()
    Returns:
      A standard architecture name

  - ### sparc_64

    public static MArchitectureName sparc_64()
    Returns:
      A standard architecture name

  - ### sparc_32

    public static MArchitectureName sparc_32()
    Returns:
      A standard architecture name

  - ### x86_64

    public static MArchitectureName x86_64()
    Returns:
      A standard architecture name

  - ### x86_32

    public static MArchitectureName x86_32()
    Returns:
      A standard architecture name

  - ### s390_64

    public static MArchitectureName s390_64()
    Returns:
      A standard architecture name

  - ### toString

    public String toString()
    Returns a string representation of this record class. The representation contains the name of the class, followed by the name and value of each of the record components.
    Specified by:
      `toString` in class `Record`
    Returns:
      a string representation of this object

  - ### compareTo

    public int compareTo(MArchitectureName o)
    Specified by:
      `compareTo` in interface `Comparable<MArchitectureName>`

  - ### hashCode

    public final int hashCode()
    Returns a hash code value for this object. The value is derived from the hash code of each of the record components.
    Specified by:
      `hashCode` in class `Record`
    Returns:
      a hash code value for this object

  - ### equals

    public final boolean equals(Object o)
    Indicates whether some other object is "equal to" this one. The objects are equal if the other object is of the same class and if all the record components are equal. All components in this record class are compared with `Objects::equals(Object,Object)`.
    Specified by:
      `equals` in class `Record`
    Parameters:
      `o` - the object with which to compare
    Returns:
      `true` if this object is the same as the `o` argument; `false` otherwise.

  - ### name

    public String name()
    Returns the value of the `name` record component.
    Returns:
      the value of the `name` record component